/**
 * Notification.java
 *
 * File generated from the XValidationReport1::Notification uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.report;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import net.ihe.gazelle.xvalidation.core.model.Assertion;

import org.w3c.dom.Node;
// End of user code

/**
 * Description of the class Notification.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Notification", propOrder = { "test", "processedInputs", "description", "assertion", "expression" })
@XmlRootElement(name = "Notification")
public class Notification implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * The unique identifier of the corresponding rule, is enough to create the link to the documentation.
	 */
	@XmlElement(name = "Test", required = true)
	private String test;
	/**
	 * Where the error was located in the message (used for filtering results).
	 */
	@XmlElement(name = "ProcessedInput", required = true)
	private List<String> processedInputs;
	/**
	 * from the rule description.
	 */
	@XmlElement(name = "Description", required = true)
	private String description;
	/**
	 * List the assertions covered by the executed rule.
	 */
	@XmlElement(name = "Assertion")
	private List<Assertion> assertion;
	
	@XmlElement(name = "Expression")
	private String expression;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * An attribute containing infos on what the XPath from the rule returned, used for unit testing debugging.
	 */
	@XmlTransient
	private String xpathReport;

	/**
	 * Return test.
	 * 
	 * @return test : The unique identifier of the corresponding rule, is enough to create the link to the documentation
	 */
	public String getTest() {
		return test;
	}

	/**
	 * Set a value to attribute test.
	 * 
	 * @param test
	 *            : The unique identifier of the corresponding rule, is enough to create the link to the documentation.
	 */
	public void setTest(String test) {
		this.test = test;
	}

	/**
	 * Return description.
	 * 
	 * @return description : from the rule description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Set a value to attribute description.
	 * 
	 * @param description
	 *            : from the rule description.
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * Return assertion.
	 * 
	 * @return assertion : List the assertions covered by the executed rule
	 */
	public List<Assertion> getAssertion() {
		if (assertion == null) {
			assertion = new ArrayList<Assertion>();
		}
		return assertion;
	}

	/**
	 * Set a value to attribute assertion.
	 * 
	 * @param assertion
	 *            : List the assertions covered by the executed rule.
	 */
	public void setAssertion(List<Assertion> assertion) {
		this.assertion = assertion;
	}

	/**
	 * Add a assertion to the assertion collection.
	 * 
	 * @param assertionElement
	 *            Element to add.
	 */
	public void addAssertion(Assertion assertionElement) {
		this.getAssertion().add(assertionElement);
	}

	/**
	 * Remove a assertion to the assertion collection.
	 * 
	 * @param assertionElement
	 *            Element to remove
	 */
	public void removeAssertion(Assertion assertionElement) {
		this.getAssertion().remove(assertionElement);
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Notification", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public List<String> getProcessedInputs() {
		if (processedInputs == null){
			processedInputs = new ArrayList<String>();
		}
		return processedInputs;
	}

	public void setProcessedInputs(List<String> processedInputs) {
		this.processedInputs = processedInputs;
	}
	
	public void addProcessedInput(String inputKeyword){
		getProcessedInputs().add(inputKeyword);
	}
	
	public void removeProcessedInput(String inputKeyword){
		getProcessedInputs().remove(inputKeyword);
	}

	public String getExpression() {
		return expression;
	}

	public void setExpression(String expression) {
		this.expression = expression;
	}

	public String getXpathReport() {
		return xpathReport;
	}

	public void setXpathReport(String xpathReport) {
		this.xpathReport = xpathReport;
	}
}